program abook;

{--$APPTYPE CONSOLE} { set this for local execution ... }

{ Address Book CGI sample v1.0 (C)2K, By Paul TOTH <tothpaul@free.fr>
  http://tothpaul.free.fr
}
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

uses
 cgi,odbc32,sysutils;

var
 drv:TSQLDriver;
 sql:TSQLStatement;
 rcd:TSQLRecordSet;
   f:integer;
   i:integer;
   s:string;
   p:integer;

function Value(parm:string):integer;
 var
  e:integer;
 begin
  parm:=parms.values[parm];
  if parm='' then result:=0 else Val(parm,Result,e);
 end;

procedure Frames;
begin
 writeln('<html><head><title>ABook</title></head>');
 writeln('<frameset rows="80,*" frameborder="0" border="0" framespacing="0" name=home>');
 writeln('<frame name="title" src="/cgi-bin/abook?f=1" scrolling="no" MARGINWIDTH="0" MARGINHEIGHT="0">');
 writeln('<frame name="main" src="/cgi-bin/abook?f=2">');
 writeln('</frameset>');
 writeln('<body>');
 writeln('Dsol, vous devez utiliser un navigateur qui supporte les frames...');
 writeln('</body></html>');
end;

procedure Title;
begin
 writeln('<html><head>');
 writeln('<script language="JavaScript">');
 writeln('<!--');
 writeln('function doAction(Action) {');
 writeln(' top.main.document.list.a.value=Action;');
 writeln(' top.main.document.list.submit();');
 writeln('}');
 writeln('//-->');
 writeln('</script>');
 writeln('</head><body bgcolor="ffffd0">');
 WriteLn('<h1>Carnet d''adresses</h1>');
 writeln('<form>');
 writeln('<input type="button" value="Ajouter" onClick="doAction(1);">');
 writeln('<input type="button" value="Supprimer" onClick="doAction(4);">');
 writeln('<input type="button" value="Page Prcdente" onClick="doAction(7);">');
 writeln('<input type="button" value="Page Suivante" onClick="doAction(8);">');
 writeln('<input type="button" value="Quitter" onClick="window.close();">');
 writeln('</form>');
 writeln('</body></html>');
end;

procedure Add;
begin
 // ajout
 sql:=drv.Execute('INSERT INTO Contacts (Name,Email) Values('''+parms.values['n']+''', '''+parms.values['e']+''')');
 sql.free;
end;

procedure Del;
begin
 // suppressions
 for i:=0 to parms.count-1 do begin
  s:=parms[i];
  if copy(s,1,2)='d=' then begin
   sql:=drv.Execute('DELETE FROM Contacts WHERE Index = '+copy(s,3,length(s)));
   sql.free;
  end;
 end;
end;

procedure Main;
 begin
  writeln('<html><body>');

  drv:=TSQLDriver.Create('DRIVER={Microsoft Access Driver (*.mdb)};DBQ=ABOOK.MDB');

  p:=value('p');

  case Value('a') of
   1:Add;
   4:Del;
   7:if p>0 then dec(p);
   8:inc(p);
  end;

 // liste
  rcd:=drv.Select('SELECT * FROM Contacts',10);
  for i:=1 to p do begin
   if not rcd.CacheNext(10) then begin
    dec(p);
    rcd.last;
    break;
   end;
  end;

  WriteLn('<form method="get" action="/cgi-bin/abook" name="list">');
  Writeln('<input type="hidden" name="a" value="0">');
  Writeln('<input type="hidden" name="f" value="2">');
  Writeln('<input type="hidden" name="p" value="',p,'">');
  WriteLn('<table WIDTH="100%" cellspacing=0>');
  writeln('<tr><td width="1%"></td><td WIDTH="50%"><input type="text" name="n"></td><td><input type="text" name="e"></td></tr>');
  for i:=1 to 10 do begin
   if rcd.eof then break;
   s:=rcd.FieldText[2];
   writeln('<tr><td width="1%" bgcolor=blue><input type="checkbox" name="d" value="',rcd.fieldText[0],'"></td><td bgcolor=blue WIDTH="50%"><font color=white>',rcd.FieldText[1],'</font></td><td bgcolor=white><a href="mailto:'+s+'">',s,'</a></td></tr>');
   rcd.next;
  end;
  WriteLn('</table>');
  WriteLn('</form>');

  writeln('</body></html>');

  rcd.free;
  drv.free;
 end;


begin
//---> /cgi-bin/abook?f=<frame>&p=<page>&a=<action>&n=<nom>&e=<email>&d=<code>
//   f : identifie la frame
// frame 1 :
//   p : numro de page
//   a : action dsire (1=ajouter, 4=supprimer, 7=page prcdent, 8=page suivante)
// ajouter :
//   n : nouveau nom
//   e : email
// supprimer :
//   d : numro d'enregistrement a supprimer (a=4)

 WriteLn('content-type: text/html');
 WriteLn;

 case Value('f') of
  0:Frames;
  1:Title;
  2:Main;
 end;

end.
